#include <iostream>
#include <bits/stdc++.h>

using namespace std;
vector<pair<string,int>>x;
int obican=0;

int main()
{
    string n;
    int nemoguce=0;
    int a,b,ab,o,p,g;
    int m[10010][4];
    cin>>p>>o>>a>>b>>ab;
    for(int i=0;i<p;i++)
    {
        cin>>n>>g;
        x.push_back(make_pair(n,g));
    }

    for(int i=0;i<p;i++)
    {
        if(x[i].first=="O")
            if(x[i].second<=o)
        {
            m[i][0]=x[i].second;
            o-=m[i][0];
        }
        else {cout<<"nemoguce";return 0;}
    }
    for(int i=0;i<p;i++)
    {
        if(x[i].first=="A")
            if(x[i].second<=a)
        {
            m[i][1]=x[i].second;
            a-=m[i][1];
        }
        else
            {
                m[i][1]=a;
                x[i].second-=a;
                m[i][0]=x[i].second;
                a=0;
                o-=x[i].second;

            }
    }
    for(int i=0;i<p;i++)
    {
        if(x[i].first=="B")
            if(x[i].second<=b)
        {
            m[i][2]=x[i].second;
            b-=m[i][2];
        }
        else
            {
                m[i][2]=b;
                x[i].second-=b;
                m[i][0]=x[i].second;
                b=0;
                o-=x[i].second;

            }
    }
    for(int i=0;i<p;i++)
    {
        if(x[i].first=="AB")
            if(x[i].second<=ab)
        {
            m[i][3]=x[i].second;
            ab-=m[i][3];
        }
        else
            {
                {
                m[i][3]=ab;
                x[i].second-=ab;
                if(o-x[i].second>=0)
                {
                    m[i][0]=x[i].second;
                    o-=x[i].second;
                    x[i].second=0;
                }
                else
                {
                    m[i][0]=o;
                x[i].second-=o;
                        if(a-x[i].second>=0)
                    {
                    m[i][1]=x[i].second;
                    a-=x[i].second;
                    x[i].second=0;
                    }
                        else
                    {
                    m[i][1]=a;
                    x[i].second-=a;
                    if(b-x[i].second>=0)
                {
                    m[i][2]=x[i].second;
                    b-=x[i].second;
                    x[i].second=0;
                }
                else
                {
                    m[i][2]=b;
                x[i].second-=b;
                nemoguce=1;
                }
                    }
                }
                }

            }
    }
    for(int i=0;i<p;i++)
    {
        for(int j=0;j<4;j++)
            if(m[i][j]<0)
 {cout<<"nemoguce";return 0;}
    }
    cout<<"moguce\n";
    for(int i=0;i<p;i++)
    {
        for(int j=0;j<4;j++)
            cout<<m[i][j]<<" ";
        cout<<"\n";
    }

    return 0;
}